"""
Sample ui test using playwright.
Refer the below doc for mode details on playwright-
https://playwright.dev/python/docs/test-runners
"""
import re
from playwright.sync_api import Page, expect
import pytest


@pytest.mark.ui
class TestUi:
    """
    Sample UI test class
    """

    def test_homepage(self, page: Page, log):
        """
        tests homepage

        Args:
            page (fixture):
            log (fixture):
        """
        log.info("starting UI test")
        page.goto("https://playwright.dev/")

        # Expect a title "to contain" a substring.
        expect(page).to_have_title(re.compile("Playwright"))

        # create a locator
        get_started = page.get_by_role("link", name="Get started")

        # Expect an attribute "to be strictly equal" to the value.
        expect(get_started).to_have_attribute("href", "/docs/intro")

        # Click the get started link.
        get_started.click()

        # Expects the URL to contain intro.
        expect(page).to_have_url(re.compile(".*intro"))
