"""
Database fixtures
"""
import pytest
from pyneers.utils.db.db_util import DBUtils
from pyneers.utils.db.db_handler import DBConfig


@pytest.fixture(scope="session")
def db_config(request):
    """
    Read DB config from cli
    """
    # Read DB config from CLI arguments
    db_type = request.config.getoption("--db_type", default="postgres")
    username = request.config.getoption("--db_username", default="")
    password = request.config.getoption("--db_password", default="")
    host = request.config.getoption("--db_host", default="")
    port = request.config.getoption("--db_port", default="")
    database_name = request.config.getoption("--db_name", default="")

    return DBConfig(
        db_type=db_type,
        username=username,
        password=password,
        host=host,
        port=port,
        database_name=database_name,
    )


@pytest.fixture(scope="session")
def db_connection(db_config):
    """
    Create DB Connection

    Args:
        db_config

    Yields:
    """
    db_utils = DBUtils(db_config=db_config)
    yield db_utils
    # Close the connection at the end of the testing session
    db_utils.close_connection()
